# Define the kmod package name here.
%define kmod_name usbip

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 2.6.32-431.el6.%{_target_cpu}}

Name:    %{kmod_name}-kmod
Version: 1.0.0
Release: 2%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.kernel.org/

BuildRequires: redhat-rpm-config
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{kmod_name}-%{version}.tar.bz2
Source1:  usbip_compat_file.h
Source2:  usbip_compat_fs.h
Source3:  usbip_device_rhel6_5.h
Source5:  GPL-v2.0.txt
Source10: kmodtool-%{kmod_name}-el6.sh

# Patches.
Patch0: ELRepo-%{kmod_name}-%{version}-Makefile.patch
Patch1: usbip_common.patch
Patch2: stub_dev.patch
Patch3: vhci_sysfs.patch

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the usbip-core, usbip-host and vhci-hcd kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -n %{kmod_name}-%{version}
%{__cp} -a %{SOURCE1} .
%{__cp} -a %{SOURCE2} .
%{__cp} -a %{SOURCE3} .
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
echo "override %{kmod_name}-core * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf
echo "override %{kmod_name}-host * weak-updates/%{kmod_name}" >> kmod-%{kmod_name}.conf
echo "override vhci-hcd * weak-updates/%{kmod_name}" >> kmod-%{kmod_name}.conf

%build
KSRC=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${KSRC}" %{?_smp_mflags} modules M=$PWD

%install
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{kmod_name}
KSRC=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${KSRC}" modules_install M=$PWD
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{SOURCE5} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} README %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Fri Dec 13 2013 Philip J Perry <phil@elrepo.org> - 1.0.0-2
- Updated to linux-3.12.4 sources.
- Fixed backported structures

* Fri Dec 13 2013 Alan Bartlett <ajb@elrepo.org> - 1.0.0-1
- Backported code from the linux-3.12.2 sources.

* Mon Nov 18 2013 Alan Bartlett <ajb@elrepo.org> - 0.0-1
- Initial el6 build of the kmod package.
- [http://elrepo.org/bugs/view.php?id=428]
